// Unnamed 3D Engine xCode module header

#include "xc-libc.h"
#include "gl.h"

typedef GLfloat vector[3];
typedef GLfloat matrix[4][4];

//#define VOID
#define VOID void

matrix mat_ident = {{1, 0, 0, 0},
					{0, 1, 0, 0},
					{0, 0, 1, 0},
					{0, 0, 0, 1}};

#define add_vector(U, V) { U[0] += V[0]; U[1] += V[1]; U[2] += V[2]; }
#define mult_vector_scalar(u, v) { u[0] *= v; u[1] *= v; u[2] *= v; }

#define EVENT_INIT 1
#define EVENT_CLOSE 2
#define EVENT_DRAW 3
#define EVENT_COLLIDE 4
#define EVENT_CREATE 5
#define EVENT_SYNC 6
#define EVENT_ACTIVATE 7
#define EVENT_LOGON 8
#define EVENT_PRE_SYNC 9
#define EVENT_POST_SYNC 10
#define EVENT_POST_CREATE 11
#define EVENT_POST_LOGON 12
#define EVENT_REMOTE_INIT 13
#define EVENT_BEGIN_MOVE 14
#define EVENT_END_MOVE 15
#define EVENT_SYNC_CLOSE 16
#define EVENT_WRITE_TEXT 17
#define EVENT_LOGOFF 18
#define EVENT_MODEL 19
#define EVENT_QUIT 20
#define EVENT_SHUTDOWN 21
#define EVENT_OLOGON 22

#define CLIENT_MOVE 1
#define CLIENT_KEY 2
#define CLIENT_LOGON 3
#define CLIENT_CMD 4
#define CLIENT_CLICK 5
#define CLIENT_INIT 6
#define CLIENT_OLOGON 7

#define ACC_PUBLIC 0
#define ACC_READ 1
#define ACC_WRITE 2
#define ACC_ALL 256

#define STAT_MOVE 1
#define STAT_ABSORB 2
#define STAT_REFLECT 3

#define UPD_POS (1<<0)
#define UPD_ROT (1<<1)
#define UPD_VEL (1<<2)
#define UPD_RV (1<<3)
#define UPD_WALK (1<<4)
#define UPD_RVEL (1<<5)
#define UPD_ALL 0xFFFFFFFF

// OpenGL rendering

	__host__ __output__ void glBegin(GLenum);
	__host__ __output__ void glEnd(void);
	__host__ __output__ void glVertex3f(GLfloat, GLfloat, GLfloat);
	__host__ __output__ void glColor3f(GLfloat, GLfloat, GLfloat);
	__host__ __output__ void glEnable(GLenum);
	__host__ __output__ void glDisable(Glenum);
	__host__ __output__ void glTexCoord2f(GLfloat, GLfloat);
	__host__ __output__ void SetTexture(__string__ char*);
	__host__ __output__ void glNormal3f(GLfloat, GLfloat, GLfloat);
	__host__ __output__ void glClear(int);
	__host__ __output__ void glMaterialfv(GLenum, GLenum, GLfloat*);
	__host__ __output__ void glMaterialf(GLenum, GLenum, GLfloat);

// Collision mesh building

	__host__ ColNode(void);
	__host__ ColBegin(void);
	__host__ ColTri(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
	__host__ ColEnd(void);

// Entity selection

	__host__ __output__ VOID OpenEnt(int, int);
	__host__ __output__ void CloseEnt(int);
	__host__ __output__ VOID SelectEnt(int);
	__host__ __output__ AddEntity(__string__ char*, __string__ char*, __string__ char*, int);
	__host__ __output__ void RemoveEntity(void);

// Entity manipulation

	__host__ GetEntID(void);
	__host__ void GetRenderMod(__string__ char*);
	__host__ void GetMod(__string__ char*);
	__host__ void GetName(__string__ char*);
	__host__ __output__ void SetName(__string__ char*);
	__host__ __output__ void SetTrans(__sync__ vector);
	__host__ void GetTrans(vector);
	__host__ __output__ void SetVel(__sync__ vector);
	__host__ void GetVel(vector);
	__host__ __output__ VOID SelectComponent(int);
	__host__ AllocCmem(int);
	__host__ GetCmem(void*, int, int);
	__host__ SetCmem(void*, int, int);
	__host__ AllocRmem(int);
	__host__ GetRmem(void*, int, int);
	__host__ SetRmem(void*, int, int);
	__host__ float GetMass(void);
	__host__ __output__ void SetMass(float);
	__host__ float GetElasticity(void);
	__host__ __output__ void SetElasticity(float);
	__host__ float GetWalk(void);
	__host__ __output__ void SetWalk(float);
	__host__ GetRot(matrix);
	__host__ __output__ void SetRot(__sync__ matrix);
	__host__ GetRotVel(matrix);
	__host__ __output__ void SetRotVel(__sync__ matrix);
	__host__ GetActive(void);
	__host__ __output__ void SetActive(int);
	__host__ GetRenderActive(void);
	__host__ __output__ void SetRenderActive(int);
	__host__ GetStationary(void);
	__host__ __output__ void SetStationary(int);
	__host__ GetGlobal(void);
	__host__ __output__ void SetGlobal(int);
	__host__ GetOwner(void);
	__host__ __output__ VOID SetOwner(int);

// World forces

	__host__ __output__ VOID AddGravity(float, float, float);

// Server data storage

	__host__ AllocSmem(int);
	__host__ GetSmem(void*, int, int);
	__host__ SetSmem(void*, int, int);

// Binding fun

	__host__ BindKey(char, int);
	__host__ __input__ void KeyPress(char);
	__host__ BindCmd(__string__ char*, int);
	__host__ __input__ void Cmd(__string__ char*, __string__ char*);
	__host__ BindClick(int);
	__host__ __input__ void Click(int, int);
	__host__ SimCmd(__string__ char*, __string__ char*);

// String arguments

	__host__ GetStringArg(char*);
	__host__ GetStringArg2(char*);

// Text sending

	__host__ LogText(char*);
	__host__ __output__ void WriteText(__string__ char*);
	__host__ void WriteMsg(__string__ char*);
	__host__ ZoneText(__string__ char*);

// 3D math

	__host__ MultVectorMatrix(vector, vector, matrix);
	__host__ MultMatrix(matrix, matrix, matrix);
	__host__ RotationMatrix(matrix, float, float, float, float);

// Fun client-server badinage

	__host__ Connect(char*, char*, char*);
	__host__ __output__ void TimeRef(time_t);
	__host__ __output__ void Quit(__string__ char*);
	__host__ GetAvatar(void);
	__host__ __output__ void SetAvatar(int);
	__host__ __output__ void SetOAvatar(int);

// UI fun

	__host__ ToggleViewMode(void);

// User management

	__host__ SetUser(int);
	__host__ SetOUser(int);
	__host__ AddUser(char*, char*, int);
	__host__ GetUserID(char*);
	__host__ DelUser(int);
	__host__ GetUname(int, char*);
	__host__ SetUname(int, char*);
	__host__ GetPass(int, char*);
	__host__ SetPass(int, char*);
	__host__ GetAcc(int);
	__host__ SetAcc(int, int);
	__host__ GetUserAvatar(int);
	__host__ NextUser(int);

// Arguments & file fetching

	__host__ GetArgs(__string__ char*);
	__host__ SetArgs(__string__ char*);
	__host__ RequireFile(__string__ char*, int, int, int);

// Frilly animation stuff

	__host__ __output__ void ModelEvent(int, int);
	__host__ Timer(int, int, int);
	__host__ RenderTimer(int, int, int);

// Suspend the laws of physics!

	__host__ GetFreeze(void);
	__host__ __output__ void SetFreeze(int);

// Local entity selection

	__host__ LocalOpenEnt(int, int);
	__host__ LocalCloseEnt(int);
	__host__ LocalSelectEnt(int);
	__host__ LocalSelectComponent(int);

// World settings

	__host__ __output__ void SetWorldInfo(float, float, float, float);
	__host__ float GetWorldX(void);
	__host__ float GetWorldY(void);
	__host__ float GetWorldZ(void);
	__host__ float GetVZoneSize(void);

// Um... other stuff

	__host__ CalcZone(void);
	__host__ __output__ void RequestUpdate(int);
	__host__ GetRV(vector);
	__host__ __output__ void SetRV(__sync__ vector);
	__host__ CallRenderModule(char*, int, int, int);
	__host__ __output__ __input__ Sync(void);
	__host__ __output__ void InformAvatar(int);

// Admin

	__host__ ShutDown(void);
