// Base commands module; fun for all
// By Adam Chlipala

#include "3d.h"

char buf1[256], buf2[256], *sp, *sp2, *sp3;
int id, n;

#define ADDUSR 50
#define DELUSR 51
#define CHNAME 52
#define CHPASS 54
#define CHACC 55
#define WHOIS 56
#define ULIST 57
#define WHOAMI 58
#define SPEECH 59
#define ME 60
#define SHUTDOWN 61

void main(int event, int arg, int arg2, int arg3)
{
	switch (event)
	{
		case EVENT_INIT:
			OpenEnt(arg, ACC_WRITE);
			SelectEnt(arg);

			BindCmd("say", SPEECH);
			BindCmd("me", ME);
			BindCmd("addusr", ADDUSR);
			BindCmd("delusr", DELUSR);
			BindCmd("chname", CHNAME);
			BindCmd("chpass", CHPASS);
			BindCmd("chacc", CHACC);
			BindCmd("whois", WHOIS);
			BindCmd("ulist", ULIST);
			BindCmd("whoami", WHOAMI);
			BindCmd("shutdown", SHUTDOWN);

			SetGlobal(1);
			SetActive(1);
			SetRenderActive(1);
			CloseEnt(arg);

			break;
		case SPEECH:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);
			strcpy(buf1, "<");
			GetName(buf2);
			strcat(buf1, buf2);
			strcat(buf1, "> ");
			GetStringArg(buf2);
			strcat(buf1, buf2);
			ZoneText(buf1);
			CloseEnt(arg2);

			break;
		case ME:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);
			strcpy(buf1, "* ");
			GetName(buf2);
			strcat(buf1, buf2);
			strcat(buf1, " ");
			GetStringArg(buf2);
			strcat(buf1, buf2);
			ZoneText(buf1);
			CloseEnt(arg2);

			break;
		case ADDUSR:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			if (GetAcc(arg3) < 256)
			{
				WriteMsg("Access denied");
				CloseEnt(arg2);
				break;
			}

			GetStringArg(buf1);
			sp = strtok(buf1, " ");
			sp2 = strtok(NULL, " ");
			n = atoi(strtok(NULL, " "));
			id = AddUser(sp, sp2, n);
			if (id < 0)
				WriteMsg("Error adding user");
			else
			{
				sprintf(buf2, "User '%s' added as #%d", sp, id);
				WriteMsg(buf2);
			}
			CloseEnt(arg2);

			break;
		case DELUSR:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			if (GetAcc(arg3) < 256)
			{
				WriteMsg("Access denied");
				CloseEnt(arg2);
				break;
			}

			GetStringArg(buf1);
			sp = strtok(buf1, " ");
			id = GetUserID(sp);
			if (id < 0)
				WriteMsg("User not found");
			else if (DelUser(id))
				WriteMsg("Error deleting user");
			else
			{
				sprintf(buf2, "User '%s' (#%d) deleted", sp, id);
				WriteMsg(buf2);
			}
			CloseEnt(arg2);

			break;
		case WHOIS:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			GetStringArg(buf1);
			sp = strtok(buf1, " ");
			id = GetUserID(sp);
			if (id < 0)
				WriteMsg("User not found");
			else
			{
				sprintf(buf2, "User #%d\nName: %s\nAccess level: %d", id, sp, GetAcc(id));
				WriteMsg(buf2);
			}
			CloseEnt(arg2);

			break;
		case CHNAME:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			GetStringArg(buf1);

			if (GetAcc(arg3) < 256)
			{
				sp = strtok(buf1, " ");
				if (SetUname(arg3, sp))
					WriteMsg("Error changing name");
				else
				{
					sprintf(buf2, "User #%d's name changed to '%s'", arg3, sp);
					WriteMsg(buf2);
				}
			}
			else
			{
				sp = strtok(buf1, " ");
				sp2 = strtok(NULL, " ");

				id = GetUserID(sp);
				if (id < 0)
					WriteMsg("User not found");
				else if (SetUname(id, sp2))
					WriteMsg("Error changing name");
				else
				{
					sprintf(buf2, "User #%d's name changed to '%s'", id, sp2);
					WriteMsg(buf2);
				}
			}
			CloseEnt(arg2);

			break;
		case CHPASS:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);
			GetStringArg(buf1);

			if (GetAcc(arg3) == 256)
			{
				sp = strtok(buf1, " ");
				sp2 = strtok(NULL, " ");

				if (!sp || !sp2)
					WriteMsg("Specify username and new password");
				else if (id < 0)
					WriteMsg("User not found");
				else
				{
					if (SetPass(id, sp2))
						WriteMsg("Error changing password");
					else
						WriteMsg("Password changed");
				}
			}
			else
			{
				sp = strtok(buf1, " ");
				sp2 = strtok(NULL, " ");

				if (!sp || !sp2)
					WriteMsg("Specify current and new passwords");
				else
				{
					GetPass(arg3, buf2);
					if (strcmp(buf2, sp))
						WriteMsg("Current password incorrect");
					else if (SetPass(arg3, sp2))
						WriteMsg("Error changing password");
					else
						WriteMsg("Password changed");
				}
			}
			CloseEnt(arg2);

			break;
		case CHACC:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			if (GetAcc(arg3) < 256)
			{
				WriteMsg("Access denied");
				CloseEnt(arg2);
				break;
			}

			GetStringArg(buf1);
			sp = strtok(buf1, " ");
			n = atoi(strtok(NULL, " "));
			id = GetUserID(sp);
			if (id < 0)
				WriteMsg("User not found");
			else if (SetAcc(id, n))
				WriteMsg("Error changing access level");
			else
			{
				sprintf(buf2, "User #%d's access level changed to %d", id, n);
				WriteMsg(buf2);
			}
			CloseEnt(arg2);

			break;
		case ULIST:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			strcpy(buf1, "Users:");
			for (n = 0; n >= 0; n = NextUser(n))
			{
				strcat(buf1, " ");
				GetUname(n, buf2);
				strcat(buf1, buf2);
			}
			WriteMsg(buf1);
			CloseEnt(arg2);

			break;
		case WHOAMI:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			GetUname(arg3, buf1);
			sprintf(buf2, "You are logged in as '%s'", buf1);
			WriteMsg(buf2);

			CloseEnt(arg2);

			break;
		case SHUTDOWN:
			OpenEnt(arg2, ACC_WRITE);
			SelectEnt(arg2);

			if (GetAcc(arg3) < 256)
			{
				WriteMsg("Access denied");
				CloseEnt(arg2);
				break;
			}

			OpenEnt(0, ACC_WRITE);
			SelectEnt(0);
			puts("Here we go!");
			ShutDown();
			CloseEnt(0);

			CloseEnt(arg2);

			break;
	}
}
