// Client module!
// By Adam Chlipala

#include "3d.h"

vector v;
matrix m;
char buf1[256], buf2[256], *sp, *sp2, *sp3, *sp4;
int n;

void main(int event, int arg, int arg2, int arg3)
{
	switch (event)
	{
		case CLIENT_INIT:
			LogText("To connect to a server:");
			LogText("/connect <address> [<username> [<password>]]");
			LogText("/vmode : Toggles between windowed and full screen modes");
			LogText("");
			break;
		case CLIENT_MOVE:
			LocalOpenEnt(n = GetAvatar(), ACC_ALL);
			LocalSelectEnt(n);
			OpenEnt(n, ACC_WRITE);
			SelectEnt(n);

			LocalSelectComponent(0);
			SelectComponent(0);

			if (arg & UPD_WALK)
				SetWalk(GetWalk());
			if (arg & UPD_POS)
			{
				GetTrans(v);
				SetTrans(v);
			}
			if (arg & UPD_VEL)
			{
				GetVel(v);
				SetVel(v);
			}
			if (arg & UPD_RV)
			{
				GetRV(m);
				SetRV(m);
			}
			if (arg & UPD_ROT)
			{
				GetRot(m);
				SetRot(m);
			}

			RequestUpdate(arg);

			CloseEnt(n);
			LocalCloseEnt(n);
			break;
		case CLIENT_CMD:
			GetStringArg(buf1);
			if (buf1[0] == '/')
			{
				for (sp = buf1; *sp && *sp != ' '; ++sp);
				if (*sp)
					*(sp++) = '\0';
				if (!strcmp(&buf1[1], "connect"))
				{
					LogText("Connecting...");
					sp2 = strtok(sp, " ");
					sp3 = strtok(NULL, " ");
					sp4 = strtok(NULL, " ");
					if (!sp3)
						sp3 = "guest";
					if (!sp4)
						sp4 = "guest";
					Connect(sp2, sp3, sp4);
				}
				else if (!strcmp(&buf1[1], "vmode"))
				{
					ToggleViewMode();
					LogText("View mode switched");
				}
				else if (!strcmp(&buf1[1], "avatar"))
				{
					sprintf(buf1, "Your avatar is entity #%d", GetAvatar());
					LogText(buf1);
				}
				else if (!strcmp(&buf1[1], "ent"))
				{
					if (!(*sp))
						LogText("Usage: ent <ID#>");
					else
					{
						n = atoi(sp);
						if (LocalOpenEnt(n, ACC_READ))
							LogText("Bad ID#");
						else
						{
							LogText("");

							LocalSelectEnt(n);
							sprintf(buf1, "Entity #%d", n);
							LogText(buf1);
							GetName(buf1);
							sprintf(buf2, "Name: %s", buf1);
							LogText(buf2);

							strcpy(buf1, "Flags:");
							if (GetActive())
								strcat(buf1, " Active");
							if (GetRenderActive())
								strcat(buf1, " RenderActive");
							if (GetStationary())
								strcat(buf1, " Stationary");
							if (GetGlobal())
								strcat(buf1, " Global");
							LogText(buf1);

							sprintf(buf1, "Mass: %d", (int)GetMass());
							LogText(buf1);
							LocalSelectComponent(0);
							GetTrans(v);
							sprintf(buf1, "Location: (%d, %d, %d)", (int)v[0], (int)v[1], (int)v[2]);
							LogText(buf1);

							LogText("");
							LocalCloseEnt(n);
						}
					}
				}
				else
					Cmd(&buf1[1], sp);
			}
			else
			{
				Cmd("say", buf1);
			}
			break;
		case CLIENT_CLICK:
			Click(arg, arg2);
			break;
		case CLIENT_OLOGON:
			InformAvatar(GetAvatar());
			break;
	}
}
