// Magic Flying Airplane render module
// By Adam Chlipala

#include "3d.h"

#define REBOUND 100
#define TURN 101
#define END_TURN 102

#define TICKS_MOVE 267
#define TICKS_TURN 90

vector v;
matrix m;

void main(int event, int arg, int arg2, int arg3)
{
	switch (event)
	{
	case EVENT_INIT:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);
		SelectComponent(0);

		SetName("Plane");
		SetStationary(STAT_MOVE);
		v[0] = 0;
		v[1] = 35;
		v[2] = 40;
		SetTrans(v);
		SetRot(mat_ident);
		v[0] = v[1] = v[2] = 0;
		SetRV(v);
		SetWalk(.3);
		RenderTimer(TICKS_MOVE, TURN, 0);

		SetArgs("plane.rsf");

		if (!RequireFile("rsf.xc", REBOUND, 0, 0))
			CallRenderModule("rsf.xc", EVENT_INIT, 0, 0);

		CloseEnt(arg);

		break;
	case REBOUND:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);

		CallRenderModule("rsf.xc", EVENT_INIT, 0, 0);

		CloseEnt(arg);

		break;
	case TURN:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);
		SelectComponent(0);

		v[0] = v[2] = 0;
		v[1] = 2;
		SetRV(v);

		RenderTimer(TICKS_TURN, END_TURN, 0);

		CloseEnt(arg);

		break;
	case END_TURN:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);
		SelectComponent(0);

		v[0] = v[1] = v[2] = 0;
		SetRV(v);

		RenderTimer(TICKS_MOVE, TURN, 0);

		CloseEnt(arg);

		break;
	}
}