// Really Stupid Format file importer
// Adam Chlipala

#include "3d.h"
#include "rsf.h"

float c[3], a[3], b[3], x[3][3], v[10];
FILE *fp;
char args[256], out[256], buf[256], *sp;
int j, k;
static n_obj;
vector vec;
char in_obj = 0, partial;
int parent, id_loc;

void import(void)
{
	sprintf(out, "rsf.xc: Loading %s", args);
	LogText(out);

	if (!(fp = fopen(args, "r")))
	{
		LogText("Can't open file!");
		return;
	}

	if (partial)
	{
		parent = ColNode();
		if (id_loc >= 0)
			SetRmem(&parent, id_loc, sizeof parent);
	}

	while (fgets(buf, 256, fp))
	{
		if (sp = strchr(buf, '\n'))
			*sp = 0;
		if (buf[0] == 'P')
		{
			if (in_obj)
				ColEnd();
			if (partial)
				SelectComponent(atoi(&buf[1]) + parent);
			else
				SelectComponent(atoi(&buf[1]));
			ColBegin();
			++n_obj;
			in_obj = 1;
		}
		else if (buf[0] == 'G')
		{
			if (in_obj)
				ColEnd();
			if (partial)
				SelectComponent(atoi(&buf[1]) + parent);
			else
				SelectComponent(atoi(&buf[1]));
			ColNode();
			++n_obj;
			in_obj = 0;
		}
		else if (buf[0] == ' ')
		{
			for (j = 0; j < 3; ++j)
			{
				for (k = 0; k < 5; ++k)
					strtok((j || k) ? NULL : &buf[1], " ");
				for (k = 0; k < 3; ++k)
					x[j][k] = atof(strtok(NULL, " "));
			}

			ColTri(x[0][0], x[0][1], x[0][2], x[1][0], x[1][1], x[1][2],
				x[2][0], x[2][1], x[2][2]);
		}
	}

	if (in_obj)
		ColEnd();

	LogText("Collision mesh loaded");

	rewind(fp);
	if (partial)
		n_obj = parent;
	else
		n_obj = 0;

	while (fgets(buf, 256, fp))
	{
		if (sp = strchr(buf, '\n'))
			*sp = 0;
		if (buf[0] == 'P' || buf[0] == 'G')
			SelectComponent(++n_obj);
		else if (buf[0] == '*')
		{
			v[0] = c[0] = atof(strtok(&buf[2], " "));
			v[1] = c[1] = atof(sp = strtok(NULL, " "));
			v[2] = c[2] = atof(sp = strtok(NULL, " "));
			v[3] = 1;
			glColor3f(c[0], c[1], c[2]);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, v);

			v[0] = 0.2;
			v[1] = 0.2;
			v[2] = 0.2;
			v[3] = 1;
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, v);

			v[0] = 0.5;
			v[1] = 0.5;
			v[2] = 0.5;
			v[3] = 1;
			glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, v);

			v[0] = 0;
			v[1] = 0;
			v[2] = 0;
			v[3] = 1;
			glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, v);

			glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 10);
		}
		else if (buf[0] == 'T')
		{
			strtok(buf, "\n");
			if (buf[1])
			{
				glEnable(GL_TEXTURE_2D);
				SetTexture(&buf[1]);
			}
			else
				glDisable(GL_TEXTURE_2D);
		}
		else if (buf[0] == 'G')
		{
			c[0] = atof(strtok(&buf[1], " "));
			c[1] = atof(strtok(NULL, " "));
			c[2] = atof(strtok(NULL, " "));
			AddGravity(c[0], c[1], c[2]);
		}
		else if (buf[0] == ' ')
		{
			glBegin(GL_POLYGON);

			for (j = 0; j < 3; ++j)
			{
				c[0] = atof(strtok((j ? NULL : &buf[1]), " "));
				c[1] = atof(strtok(NULL, " "));
				glTexCoord2f(c[0], c[1]);

				c[0] = atof(strtok(NULL, " "));
				c[1] = atof(strtok(NULL, " "));
				c[2] = atof(strtok(NULL, " "));
				glNormal3f(c[0], c[1], c[2]);

				c[0] = atof(strtok(NULL, " "));
				c[1] = atof(strtok(NULL, " "));
				c[2] = atof(strtok(NULL, " "));
				glVertex3f(c[0], c[1], c[2]);
			}

			glEnd();
		}
	}

	LogText("Graphics loaded");

	if (!partial)
		SetRenderActive(1);

	fclose(fp);

	CallRenderModule(0, RSF_LOADED, 0, 0);
}

void main(int e, int a, int a2, int a3)
{
	id_loc = a2;
	partial = a3;
	switch (e)
	{
	case EVENT_INIT:
		OpenEnt(a, ACC_WRITE);
		SelectEnt(a);

		GetArgs(args);
		if (!RequireFile(args, 23, a2, a3))
			import();

		CloseEnt(a);

		break;
	case 23:
		OpenEnt(a, ACC_WRITE);
		SelectEnt(a);

		GetArgs(args);
		import();

		CloseEnt(a);

		break;
	}
}
