// Tic-Tac-Toe render module
// Adam Chlipala

#include "3d.h"
#include "rsf.h"

#define DRAW_X_BLUE 110
#define DRAW_X_RED 111
#define CLEAR 112

vector v;
int j, k, n;
GLfloat red[] = {1, 0, 0, 1}, blue[] = {0, 0, 1, 1}, grey[] = {.8, .8, .8, 1};

void main(int event, int arg, int arg2, int arg3)
{
	switch (event)
	{
	case EVENT_INIT:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);

		SetArgs("board.rsf");

		if (!RequireFile("rsf.xc", 23, 0, 0))
			CallRenderModule("rsf.xc", EVENT_INIT, -1, 1);

		CloseEnt(arg);

		break;
	case 23:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);

		CallRenderModule("rsf.xc", EVENT_INIT, -1, 1);

		CloseEnt(arg);

		break;
	case RSF_LOADED:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);

		for (j = 0; j < 3; ++j)
			for (k = 0; k < 3; ++k)
			{
				SelectComponent(0);
				n = ColNode();

				glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, grey);
				glBegin(GL_POLYGON);
				glVertex3f(.95, 0, .95);
				glVertex3f(-.95, 0, .95);
				glVertex3f(-.95, 0, -.95);
				glVertex3f(.95, 0, -.95);
				glEnd();

				v[1] = 0.75;
				v[0] = -2 + j * 2;
				v[2] = -2 + k * 2;
				SetTrans(v);
			}

		for (j = 0; j < 9; ++j)
		{
			SelectComponent(3 + j);
			ColNode();
		}

		SetRenderActive(1);

		CloseEnt(arg);

		break;
	case DRAW_X_BLUE:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);
		SelectComponent(arg2);

		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, blue);

		glBegin(GL_POLYGON);
		glVertex3f(-.9, .15, .9);
		glVertex3f(-.3, .15, .9);
		glVertex3f(.9, .15, -.9);
		glVertex3f(.3, .15, -.9);
		glEnd();

		glBegin(GL_POLYGON);
		glVertex3f(.9, .1, .9);
		glVertex3f(.3, .1, .9);
		glVertex3f(-.9, .1, -.9);
		glVertex3f(-.3, .1, -.9);
		glEnd();

		SelectComponent(0);

		CloseEnt(arg);

		break;
	case DRAW_X_RED:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);
		SelectComponent(arg2);

		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, red);

		glBegin(GL_POLYGON);
		glVertex3f(-.9, .15, .9);
		glVertex3f(-.3, .15, .9);
		glVertex3f(.9, .15, -.9);
		glVertex3f(.3, .15, -.9);
		glEnd();

		glBegin(GL_POLYGON);
		glVertex3f(.9, .1, .9);
		glVertex3f(.3, .1, .9);
		glVertex3f(-.9, .1, -.9);
		glVertex3f(-.3, .1, -.9);
		glEnd();

		SelectComponent(0);

		CloseEnt(arg);

		break;
	case CLEAR:
		OpenEnt(arg, ACC_WRITE);
		SelectEnt(arg);

		for (j = 12; j < 23; ++j)
		{
			SelectComponent(j);
			glClear(0);
		}

		CloseEnt(arg);

		break;

	}
}