#define NULL 0

typedef int size_t;
typedef void FILE;
typedef int fpos_t;
typedef int clock_t;
typedef int time_t;

#define stdin ((FILE*)1)
#define stdout ((FILE*)2)
#define stderr ((FILE*)3)

typedef int va_list;
// This needs to be handled

typedef struct
{
	int quot, rem;
} div_t;

typedef struct
{
	long quot, rem;
} ldiv_t;

struct tm
{
	int tm_sec, tm_min, tm_hour, tm_mday, tm_mon, tm_year, tm_wday, tm_yday, tm_isdst;
};

__host__ isalnum(int);
__host__ isalpha(int);
__host__ iscntrl(int);
__host__ isdigit(int);
__host__ isgraph(int);
__host__ islower(int);
__host__ isprint(int);
__host__ ispunct(int);
__host__ isspace(int);
__host__ isupper(int);
__host__ isxdigit(int);
__host__ tolower(int);
__host__ toupper(int);

__host__ double acos(double);
__host__ double asin(double);
__host__ double atan(double);
__host__ double atan2(double, double);
__host__ double cos(double);
__host__ double sin(double);
__host__ double tan(double);
__host__ double cosh(double);
__host__ double sinh(double);
__host__ double tanh(double);
__host__ double exp(double);
__host__ double frexp(double, int*);
__host__ double ldexp(double, int);
__host__ double log(double);
__host__ double log10(double);
__host__ double modf(double, double*);
__host__ double pow(double, double);
__host__ double sqrt(double);
__host__ double ceil(double);
__host__ double fabs(double);
__host__ double floor(double);
__host__ double fmod(double, double);

__host__ remove(const char*);
__host__ rename(const char*, const char*);
__host__ FILE *tmpfile(void);
__host__ char * tmpnam(char*);
__host__ fclose(FILE*);
__host__ fflush(FILE*);
__host__ FILE *fopen(const char*, const char*);
__host__ FILE *freopen(const char*, const char*, FILE*);
__host__ void setbuf(FILE*, char*);
__host__ setvbuf(FILE*, char*, int, size_t);
__host__ fprintf(FILE*, const char*, ...);
__host__ fscanf(FILE*, const char*, ...);
__host__ printf(const char*, ...);
__host__ scanf(const char*, ...);
__host__ sprintf(char*, const char*, ...);
__host__ sscanf(const char*, const char*, ...);
__host__ fgetc(FILE*);
__host__ char *fgets(char*, int, FILE*);
__host__ fputc(int, FILE*);
__host__ fputs(const char*, FILE*);
__host__ getc(FILE*);
__host__ getchar(void);
__host__ char *gets(char*);
__host__ putc(int, FILE*);
__host__ putchar(int);
__host__ puts(const char*);
__host__ ungetc(int, FILE*);
__host__ size_t fread(void*, size_t, size_t, FILE*);
__host__ size_t fwrite(void*, size_t, size_t, FILE*);
__host__ fgetpos(FILE*, fpos_t*);
__host__ fseek(FILE*, long, int);
__host__ fsetpos(FILE*, fpos_t*);
__host__ long ftell(FILE*);
__host__ void rewind(FILE*);
__host__ void clearerr(FILE*);
__host__ feof(FILE*);
__host__ ferror(FILE*);
__host__ void perror(const char*);

__host__ double atof(const char*);
__host__ atoi(const char*);
__host__ long atol(const char*);
__host__ double strtod(const char*, char**);
__host__ long strtol(const char*, char**, int);
__host__ unsigned long strtoul(const char*, char**, int);
__host__ rand(void);
__host__ void srand(unsigned int);
__host__ void *calloc(size_t, size_t);
__host__ void free(void*);
__host__ void *malloc(size_t);
__host__ void *realloc(void*, size_t);
__host__ void abort(void);
__host__ atexit(void (*)(void));
__host__ void exit(int);
__host__ char *getenv(const char*);
__host__ system(const char*);
__host__ void *bsearch(const void*, const void*, size_t, size_t, int (*)(const void*, const void*));
__host__ void qsort(void*, size_t, size_t, int (*)(const void*, const void*));
__host__ abs(int);
__host__ div_t div(int, int);
__host__ long labs(long);
__host__ ldiv_t ldiv(long, long);

__host__ void *memcpy(void*, const void*, size_t);
__host__ void *memmove(void*, const void*, size_t);
__host__ char *strcpy(char*, const char*);
__host__ char *strncpy(char*, const char*, size_t);
__host__ char *strcat(char*, const char*);
__host__ char *strncat(char*, const char*, size_t);
__host__ memcmp(const void*, const void*, size_t);
__host__ strcmp(const char*, const char*);
__host__ strncmp(const char*, const char*, size_t);
__host__ size_t strxfrm(char*, const char*, size_t);
__host__ void *memchr(const void*, int, size_t);
__host__ char *strchr(const char*, int);
__host__ size_t strcspn(const char*, const char*);
__host__ char *strpbrk(const char*, const char*);
__host__ char *strrchr(const char*, int);
__host__ size_t strspn(const char*, const char*);
__host__ char *strstr(const char*, const char*);
__host__ char *strtok(char*, const char*);
__host__ void memset(void*, int, size_t);
__host__ char *strerror(int);
__host__ size_t strlen(const char*);

__host__ clock_t clock(void);
__host__ double difftime(time_t, time_t);
__host__ time_t mktime(struct tm*);
__host__ time_t time(time_t*);
__host__ char *asctime(const struct tm*);
__host__ char *ctime(const struct tm*);
__host__ struct tm *gmtime(const time_t*);
__host__ struct tm *localtime(const time_t*);
__host__ size_t strftime(char*, size_t, const char*, const struct tm*);
